lbu.in 13.8 KB
Newer Older
Natanael Copa's avatar
Natanael Copa committed
1 2 3 4 5 6
#!/bin/sh

# lbu - utility to create local backups.
# Copyright (c) 2006 Natanael Copa
# May be distributed under GPL2

7
VERSION=@VERSION@
Natanael Copa's avatar
Natanael Copa committed
8
sysconfdir=@sysconfdir@
Natanael Copa's avatar
Natanael Copa committed
9

10 11
if [ ! -f ${libalpine:="./libalpine.sh"} ]; then
	libalpine=/usr/share/lbu/libalpine.sh
12 13 14
	if [ ! -f "$libalpine" ]; then
		libalpine=/lib/libalpine.sh
	fi
15 16
fi
. $libalpine || exit 1
Natanael Copa's avatar
Natanael Copa committed
17

Natanael Copa's avatar
Natanael Copa committed
18 19
EXCLUDE_LIST="$sysconfdir"/exclude
INCLUDE_LIST="$sysconfdir"/include
Natanael Copa's avatar
Natanael Copa committed
20

Natanael Copa's avatar
Natanael Copa committed
21 22
DEFAULT_CIPHER="aes-256-cbc"

Natanael Copa's avatar
Natanael Copa committed
23
LBU_CONF="$sysconfdir"/lbu.conf
Natanael Copa's avatar
Natanael Copa committed
24 25
if [ -f "$LBU_CONF" ]; then
	. "$LBU_CONF"
26 27
fi

Natanael Copa's avatar
Natanael Copa committed
28 29
UMOUNT_LIST=

Natanael Copa's avatar
Natanael Copa committed
30 31 32 33 34 35 36 37
usage() {
	echo "$PROGRAM $VERSION"
	echo "usage: $PROGRAM <subcommand> [options] [args]

Available subcommands:
  commit (ci)
  exclude (ex, delete)
  include (inc, add)
38 39
  list (ls)
  package (pkg)
Natanael Copa's avatar
Natanael Copa committed
40
  status (stat, st)
41
  list-backup (lb) 
Natanael Copa's avatar
Natanael Copa committed
42
  revert
Natanael Copa's avatar
Natanael Copa committed
43 44 45 46 47 48 49 50 51

Common options:
 -h	Show help for subcommand.
 -q	Quiet mode.
 -v	Verbose mode.
"
	exit 1
}

Natanael Copa's avatar
Natanael Copa committed
52 53 54 55 56 57 58 59 60 61 62 63 64
cleanup() {
	local i
	for i in $UMOUNT_LIST; do
		umount $i
	done
}

exit_clean() {
	cleanup
	exit 1
}

mount_once() {
65
	if ! grep $1 /proc/mounts >/dev/null; then
Natanael Copa's avatar
Natanael Copa committed
66 67 68 69
		mount $1 && UMOUNT_LIST="$1 $UMOUNT_LIST"
	fi
}

Natanael Copa's avatar
Natanael Copa committed
70 71 72
# create backupfile
backup_apkovl() {
	local outfile="$1"
73
	local d=$( date -u -r "$outfile" "+%Y%m%d%H%M%S" )
Natanael Copa's avatar
Natanael Copa committed
74 75 76 77 78 79 80
	local backup=$(echo "$outfile" | sed "s/\.apkovl\.tar\.gz/.$d.tar.gz/")
	vecho "Creating backup $backup"
	if [ -z "$DRYRUN" ]; then
		mv "$outfile" "$backup"
	fi
}

Natanael Copa's avatar
Natanael Copa committed
81
# verify we have openssl if we want to encrypt
82 83 84
check_openssl() {
	[ -z "$ENCRYPTION" ] && return 0
	OPENSSL=$(which openssl 2>/dev/null) || die "openssl was not found"
Natanael Copa's avatar
Natanael Copa committed
85

86 87 88
	$OPENSSL list-cipher-commands | grep "^$ENCRYPTION$" > /dev/null \
		|| die "Cipher $ENCRYPTION is not supported"
}
Natanael Copa's avatar
Natanael Copa committed
89 90 91 92 93 94 95 96 97

# list_add(char *listfile, char* file...)
list_add() {
	local list="$1"
	shift
	mkdir -p `dirname "$list"`
	while [ $# -gt 0 ] ; do
		filename=`echo "$1" | sed 's:^/\+::'`
		if grep "^$filename$" "$list" >/dev/null 2>&1 ; then
98
			vecho "$filename is already in $list."
Natanael Copa's avatar
Natanael Copa committed
99
		else
100
			vecho "Adding $filename to $list."
Natanael Copa's avatar
Natanael Copa committed
101 102 103 104 105 106 107 108 109 110 111 112 113 114 115
			echo "$filename" >> "$list"
		fi
		shift
	done
}

# list_delete(char *listfile, char *file...)
list_delete() {
	local list="$1"
	local tmp="$list.old"
	shift
	[ -f "$list" ] || return 1
	while [ $# -gt 0 ] ; do
		filename=`echo "$1" | sed 's:^/\+::'`
		mv "$list" "$tmp"
116
		vecho "Removing $filename from list."
Natanael Copa's avatar
Natanael Copa committed
117 118 119 120 121 122
		grep -v "^$filename$" "$tmp" > "$list"
		rm "$tmp"
		shift
	done
}

123 124 125 126 127 128 129 130 131 132 133 134 135 136 137 138 139 140 141 142 143 144 145 146 147
# unpack archive on LBU_MEDIA to given dir
unpack_apkovl() {
	local f="$(hostname).apkovl.tar.gz"
	local dest="$1"
	local mnt="/media/$LBU_MEDIA"
	local count=0
	mkdir -p "$dest"
	mount_once "$mnt"
	if [ ! -f "$mnt/$f" ]; then
		return 1
	fi
	if [ -z "$ENCRYPTION" ]; then
		tar -C "$dest" -zxf "$mnt/$f"
		return
	fi
	f="$f.$ENCRYPTION"
	check_openssl
        while [ $count -lt 3 ]; do
		$OPENSSL enc -d -$ENCRYPTION -in "$mnt/$f" | tar \
			-C "$dest" -zx 2>/dev/null && return 0
		count=$(( $count + 1 ))
	done
	cleanup
	die "Failed to unpack $mnt/$f"
}		
148

Natanael Copa's avatar
Natanael Copa committed
149 150 151 152 153
#
# lbu_include - add/remove files to include list
#
usage_include() {
	echo "$PROGRAM $VERSION
Natanael Copa's avatar
Natanael Copa committed
154
Add filename(s) to include list ($sysconfdir/include)
155 156 157

usage: $PROGRAM include|inc|add [-rv] <file> ...
       $PROGRAM include|inc|add [-v] -l
Natanael Copa's avatar
Natanael Copa committed
158 159 160 161 162 163 164 165 166 167 168 169 170 171 172

Options:
  -l	List contents of include list.
  -r	Remove specified file(s) from include list instead of adding.
  -v	Verbose mode.
"
	exit 1
}

cmd_include() {
	if [ "$LIST" ] ; then
		[ $# -gt 0 ] && usage_include
		show_include
		return
	fi
173

Natanael Copa's avatar
Natanael Copa committed
174 175 176 177 178 179 180 181 182 183 184
	[ $# -lt 1 ] && usage_include
	if [ "$REMOVE" ] ; then
		list_delete "$INCLUDE_LIST" "$@"
	else
		list_add "$INCLUDE_LIST" "$@"
		list_delete "$EXCLUDE_LIST" "$@"
	fi
}

show_include() {
	if [ -f "$INCLUDE_LIST" ] ; then
185
		vecho "Include files:"
Natanael Copa's avatar
Natanael Copa committed
186 187 188 189
		cat "$INCLUDE_LIST"
	fi
}

190 191 192 193 194 195 196 197 198 199 200 201 202 203 204 205 206 207
#
# lbu_package - create a package
#
usage_package() {
	echo "$PROGRAM $VERSION
Create backup package.

usage: $PROGRAM package|pkg -v [<dirname>|<filename>]

Options:
  -v	Verbose mode.

If <dirname> is a directory, a package named <hostname>.apkovl.tar.gz will
be created in the specified directory.

If <filename> is specified, and is not a direcotry, a package with the
specified name willbe created.

208
If <dirname> nor <filename> is not specified, a package named
209 210 211 212 213 214 215 216 217
<hostname>.apkovl.tar.gz will be created in current work directory.
"
	exit 1
}

cmd_package() {
	local pkg="$1"
	local rc=0
	local owd="$PWD"
218
	local suff="apkovl.tar.gz"
Natanael Copa's avatar
Natanael Copa committed
219
	local tmpdir tmppkg
220 221

	check_openssl
Natanael Copa's avatar
Natanael Copa committed
222
	init_tmpdir tmpdir
223 224

	[ -n "$ENCRYPTION" ] && suff="$suff.$ENCRYPTION"
225 226 227

	# find filename
	if [ -d "$pkg" ] ; then
228
		pkg="$pkg/$(hostname).$suff"
229
	elif [ -z "$pkg" ]; then
230
		pkg="$PWD/$(hostname).$suff"
231 232
	fi

Natanael Copa's avatar
Natanael Copa committed
233 234
	tmppkg="$tmpdir/$(basename $pkg)"

235
	cd "${ROOT:-/}"
236
	# remove old package.list
237
	if [ -f etc/lbu/packages.list ] && [ -f var/lib/apk/world ]; then
238 239 240 241
		echo "Note: Removing /etc/lbu/packages.list."
		echo "      /var/lib/apk/world will be used."
		rm -f etc/lbu/packages.list
	fi
242
	currentlist=$(apk audit --backup -q)
243 244 245
	if [ -f var/lib/apk/world ]; then
		currentlist="$currentlist var/lib/apk/world"
	fi
246

247 248 249
	# create tar archive
	[ -f "$EXCLUDE_LIST" ] && excl="-X $EXCLUDE_LIST"
	[ -f "$INCLUDE_LIST" ] && incl="-T $INCLUDE_LIST"
Natanael Copa's avatar
Natanael Copa committed
250 251 252 253 254
	if [ -n "$VERBOSE" ]; then
		echo "Archiving the following files:" >&2
		# we dont want to mess the tar output with the
		# password prompt. Lets get the tar output first.
		tar  $excl $incl -c -v $currentlist > /dev/null
Natanael Copa's avatar
Natanael Copa committed
255
		rc=$?
Natanael Copa's avatar
Natanael Copa committed
256 257 258 259
	fi
	if [ $rc -eq 0 ]; then
		if [ -z "$ENCRYPTION" ]; then
			tar $excl $incl -c $currentlist | gzip -c  >"$tmppkg"
Natanael Copa's avatar
Natanael Copa committed
260
			rc=$?
Natanael Copa's avatar
Natanael Copa committed
261
		else
Natanael Copa's avatar
Natanael Copa committed
262 263 264 265 266
			set -- enc "-$ENCRYPTION" -salt
			[ -n "$PASSWORD" ] && set -- "$@" -pass pass:"$PASSWORD"
			tar $excl $incl -c $currentlist | gzip -c \
				| $OPENSSL "$@" > "$tmppkg"
			rc=$?
267
		fi
268
	fi
Natanael Copa's avatar
Natanael Copa committed
269
	cd "$owd"
Natanael Copa's avatar
Natanael Copa committed
270

Natanael Copa's avatar
Natanael Copa committed
271
	# actually commit unless dryrun mode
Natanael Copa's avatar
Natanael Copa committed
272
	if [ $rc -eq 0 ]; then
273 274 275 276 277 278 279
		if [ -z "$DRYRUN" ]; then
			if [ "x$pkg" = "x-" ]; then
				cat "$tmppkg"
			else
				cp "$tmppkg" "$pkg"
			fi
		fi
Natanael Copa's avatar
Natanael Copa committed
280
		vecho "Created $pkg"
Natanael Copa's avatar
Natanael Copa committed
281
	fi
282 283 284 285 286 287 288 289 290 291 292 293 294 295 296 297 298 299 300
	return $rc
}

#
# lbu list - list files that would go to archive
#
usage_list() {
	echo "$PROGRAM $VERSION
Lists files that would go to tar package. Same as: 'lbu package -v /dev/null'

usage: $PROGRAM list|ls
"
	exit 1
}

cmd_list() {
	VERBOSE="-v"
	cmd_package /dev/null
}
Natanael Copa's avatar
Natanael Copa committed
301 302 303 304 305 306

#
# lbu_commit - commit config files to writeable media
#
usage_commit() {
	echo "$PROGRAM $VERSION
307 308 309
Create a backup of config to writeable media.

usage: $PROGRAM commit|ci [-nv] [<media>]
Natanael Copa's avatar
Natanael Copa committed
310 311

Options:
Natanael Copa's avatar
Natanael Copa committed
312
  -d	Remove old apk overlay files.
313
  -e	Protect configuration with a password.
Natanael Copa's avatar
Natanael Copa committed
314
  -n	Don't commit, just show what would have been commited.
Natanael Copa's avatar
Natanael Copa committed
315
  -p <password>	Give encryption password on the command-line
Natanael Copa's avatar
Natanael Copa committed
316 317 318 319
  -v	Verbose mode.

The following values for <media> is supported: floppy usb
If <media> is not specified, the environment variable LBU_MEDIA will be used.
Natanael Copa's avatar
Natanael Copa committed
320

321
Password protection will use $DEFAULT_CIPHER encryption. Other ciphers can be
Natanael Copa's avatar
Natanael Copa committed
322 323 324
used by setting the DEFAULT_CIPHER or ENCRYPTION environment variables.
For possible ciphers, try: openssl -v

Natanael Copa's avatar
Natanael Copa committed
325 326
The password used to encrypt the file, can either be specified with the -p
option or using the PASSWORD environment variable.
327

Natanael Copa's avatar
Natanael Copa committed
328
The environment varialbes can also be set in $LBU_CONF
Natanael Copa's avatar
Natanael Copa committed
329 330 331 332 333
"
	exit 1
}

cmd_commit() {
Natanael Copa's avatar
Natanael Copa committed
334
	local media mnt statuslist tmplist currentlist
335 336 337 338
	local incl excl outfile ovls lines

	check_openssl

Natanael Copa's avatar
Natanael Copa committed
339 340 341
	# turn on verbose mode if dryrun
	[ -n "$DRYRUN" ] && VERBOSE="-v"

342
	# find what media to use
Natanael Copa's avatar
Natanael Copa committed
343
	media="${1:-$LBU_MEDIA}"
Natanael Copa's avatar
Natanael Copa committed
344 345
	[ -z "$media" ] && usage_commit

346
	# mount media unles its already mounted
Natanael Copa's avatar
Natanael Copa committed
347
	mnt=/media/$media
Natanael Copa's avatar
Natanael Copa committed
348
	[ -d "$mnt" ] || usage
Natanael Copa's avatar
Natanael Copa committed
349
	mount_once "$mnt" || die "failed to mount $mnt"
Natanael Copa's avatar
Natanael Copa committed
350

Natanael Copa's avatar
Natanael Copa committed
351 352 353 354 355 356
	# find the outfile
	outfile="$mnt/$(hostname).apkovl.tar.gz"
	if [ -n "$ENCRYPTION" ]; then
		outfile="$outfile.$ENCRYPTION"
	fi

Natanael Copa's avatar
Natanael Copa committed
357

Natanael Copa's avatar
Natanael Copa committed
358
	# remove old config files
359
	if [ -n "$DELETEOLDCONFIGS" ] ; then
Natanael Copa's avatar
Natanael Copa committed
360 361 362 363
		local rmfiles=$(ls "$mnt/"*.apkovl.tar.gz* 2>/dev/null)
		if [ -n "$rmfiles" ] ; then
			if [ -n "$VERBOSE" ]; then
				echo "Removing old apk overlay files:" >&2
364
				echo "$rmfiles"
Natanael Copa's avatar
Natanael Copa committed
365
				echo "" >&2
366
			fi
Natanael Copa's avatar
Natanael Copa committed
367
			[ -z "$DRYRUN" ] && rm "$mnt/"*.apkovl.tar.gz*
368 369
		fi
	else
Natanael Copa's avatar
Natanael Copa committed
370
       		lines=$(ls -1 "$mnt"/*.apkovl.tar.gz* 2>/dev/null)
Natanael Copa's avatar
Natanael Copa committed
371
		if [ "$lines" = "$outfile" ]; then
Natanael Copa's avatar
Natanael Copa committed
372
			backup_apkovl "$outfile"
Natanael Copa's avatar
Natanael Copa committed
373
		elif [ -n "$lines" ]; then
374
	               	# More then one apkovl, this is a security concern
Natanael Copa's avatar
Natanael Copa committed
375
			cleanup
Natanael Copa's avatar
Natanael Copa committed
376 377 378 379
			eecho "The following apkovl file(s) were found:"
			eecho "$lines"
			eecho ""
	               	die "Please use -d to replace."
380
		fi
Natanael Copa's avatar
Natanael Copa committed
381
	fi
382 383 384

	# create package
	if ! cmd_package "$outfile"; then
Natanael Copa's avatar
Natanael Copa committed
385
		cleanup
Natanael Copa's avatar
Natanael Copa committed
386
		die "Problems creating archive. aborting"
387
	fi
Natanael Copa's avatar
Natanael Copa committed
388

389 390
	# delete old backups if needed
	# poor mans 'head -n -N' done with awk.
391
	ls "$mnt"/$(hostname).[0-9][0-9][0-9][0-9]*[0-9].tar.gz 2>/dev/null \
392 393 394 395 396 397 398
		| awk '{ a[++i] = $0; } END { 
			print a[0]; 
			while (i-- > '"${BACKUP_LIMIT:-0}"') { 
				print a[++j] 
			}
		}' | xargs rm 2>/dev/null

Natanael Copa's avatar
Natanael Copa committed
399
	# remove obsolete file. some older version of alpine needs this
400
	# to be able to upgrade
401 402
	if [ -z "$DRYRUN" ] && [ -f $mnt/packages.list ]; then
		echo "Note: Removing packages.list from $(basename $mnt)."
403
		echo "      /var/lib/apk/world will be used."
404 405
		rm -f $mnt/packages.list
	fi
Natanael Copa's avatar
Natanael Copa committed
406

Natanael Copa's avatar
Natanael Copa committed
407
	# make sure data is written
Natanael Copa's avatar
Natanael Copa committed
408
	sync
Natanael Copa's avatar
Natanael Copa committed
409
	[ "$media" = "floppy" ] && sleep 1
Natanael Copa's avatar
Natanael Copa committed
410 411

	# move current to commited.
412
	vecho "Successfully saved apk overlay files"
Natanael Copa's avatar
Natanael Copa committed
413 414 415 416 417 418 419
}

#---------------------------------------------------------------------------
# lbu_exclude - add remove file(s) from exclude list

usage_exclude() {
	echo "$PROGRAM $VERSION
Natanael Copa's avatar
Natanael Copa committed
420
Add filename(s) to exclude list ($sysconfdir/exclude)
421 422 423

usage: $PROGRAM exclude|ex|delete [-rv] <file> ...
       $PROGRAM exclude|ex|delete [-v] -l
Natanael Copa's avatar
Natanael Copa committed
424 425 426 427 428 429 430 431 432 433 434 435 436 437 438

Options:
  -l	List contents of exclude list.
  -r	Remove specified file(s) from exclude list instead of adding.
  -v	Verbose mode.
"
	exit 1
}

cmd_exclude() {
	if [ "$LIST" ] ; then
		[ $# -gt 0 ] && usage_exclude
		show_exclude
		return
	fi
439

Natanael Copa's avatar
Natanael Copa committed
440 441 442 443 444 445 446 447 448 449 450
	[ $# -lt 1 ] && usage_exclude
	if [ "$REMOVE" ] ; then
		list_delete "$EXCLUDE_LIST" "$@"
	else
		list_delete "$INCLUDE_LIST" "$@"
		list_add "$EXCLUDE_LIST" "$@"
	fi
}

show_exclude() {
	if [ -f "$EXCLUDE_LIST" ] ; then
451
		vecho "Exclude files:"
Natanael Copa's avatar
Natanael Copa committed
452
		cat "$EXCLUDE_LIST"
453
	fi
Natanael Copa's avatar
Natanael Copa committed
454 455
}

Natanael Copa's avatar
Natanael Copa committed
456
#---------------------------------------------------------------------------
457
# lbu_listbackup - Show old commits
458
usage_listbackup() {
Natanael Copa's avatar
Natanael Copa committed
459 460 461 462
	cat <<EOF
$PROGRAM $VERSION
Show old commits.

463
usage: $PROGRAM list-backup [<media>]
Natanael Copa's avatar
Natanael Copa committed
464 465 466 467 468

EOF
	exit 1
}

469
cmd_listbackup() {
Natanael Copa's avatar
Natanael Copa committed
470 471
	local media=${1:-"$LBU_MEDIA"}
	local mnt="/media/$media"
Natanael Copa's avatar
Natanael Copa committed
472
	[ -z "$media" ] && usage_listbackup
Natanael Copa's avatar
Natanael Copa committed
473 474 475 476 477 478 479 480

	mount_once "$mnt" || die "failed to mount $mnt"
	ls -1 "$mnt"/*.[0-9][0-9]*[0-9][0-9].tar.gz* 2>/dev/null | sed 's:.*/::'
}

#---------------------------------------------------------------------------
# lbu_revert - revert to old config
usage_revert() {
Natanael Copa's avatar
Natanael Copa committed
481 482 483 484 485 486
	cat <<EOF
$PROGRAM $VERSION
Revert to older commit.

usage: $PROGRAM revert <REVISION> [<media>]

Natanael Copa's avatar
Natanael Copa committed
487
The revision should be one of the files listed by 'lbu list-backup'.
Natanael Copa's avatar
Natanael Copa committed
488

Natanael Copa's avatar
Natanael Copa committed
489
EOF
Natanael Copa's avatar
Natanael Copa committed
490 491 492 493
}

cmd_revert() {
	local media=${2:-"$LBU_MEDIA"}
Natanael Copa's avatar
Natanael Copa committed
494 495 496 497 498 499
	[ -z "$media" ] && usage_revert
	local mnt="/media/$media"
	local revertto="$mnt/$1"
	local current="$mnt/$(hostname).apkovl.tar.gz"

	if [ -n "$ENCRYPTION" ]; then
500
		current="$current.$ENCRYPTION"
Natanael Copa's avatar
Natanael Copa committed
501 502 503
	fi
	mount_once "$mnt" || die "failed to mount $mnt"
	[ -f "$revertto" ] || die "file not found: $revertto"
504
	backup_apkovl "$current"
Natanael Copa's avatar
Natanael Copa committed
505
	vecho "Reverting to $1"
506
	[ -z "$DRYRUN" ] && mv "$revertto" "$current"
Natanael Copa's avatar
Natanael Copa committed
507 508
}

Natanael Copa's avatar
Natanael Copa committed
509 510 511 512 513 514
#---------------------------------------------------------------------------
# lbu_status - check what files have been changed since last save
usage_status() {
	echo "$PROGRAM $VERSION
Check what files have been changed since last commit.

515
usage: $PROGRAM status|st [-av]
Natanael Copa's avatar
Natanael Copa committed
516 517 518 519 520 521 522 523

Options:
  -a	Compare all files, not just since last commit.
  -v	Also show include and exclude lists.
"
	exit 1
}

524 525 526 527 528
cmd_status() {
	if [ -n "$USE_DEFAULT" ]; then
		apk audit --backup
		return 0
	fi
529 530 531 532 533 534 535 536 537
	LBU_MEDIA=${1:-"$LBU_MEDIA"}
	[ -z "$LBU_MEDIA" ] && usage_status
	local tmp
	init_tmpdir tmp
	mkdir -p "$tmpdir/a" "$tmp/b"

	# unpack last commited apkovl to tmpdir/a
	unpack_apkovl "$tmp/a"

538
	# generate new apkovl and extract to tmpdir/b
539 540
	cmd_package - | tar -C "$tmp/b" -zx

541
	# show files that exists in a but not in b as deleted
542 543 544 545 546 547 548
	local f
	( cd "$tmp"/a && find ) | while read f; do
		f=${f#./}
		[ "$f" = "." ] && continue
		[ -e "$tmp/b/$f" ] || echo "D $f"
	done
	
549
	# compare files in b with files in a
550 551 552 553 554 555 556
	( cd "$tmp"/b && find ) | while read f; do
		f=${f#./}
		[ "$f" = "." ] && continue
		local a="$tmp/a/$f"
		local b="$tmp/b/$f"
		if [ ! -e "$a" ]; then
			echo "A $f"
Natanael Copa's avatar
Natanael Copa committed
557 558
		elif [ -f "$a" ] && [ -f "$b" ] && [ "$b" -nt "$a" ] \
		     && ! cmp -s "$a" "$b"; then
559 560 561
			echo "U $f"
		fi
	done
562 563
}

Natanael Copa's avatar
Natanael Copa committed
564

565 566 567 568 569 570 571 572 573 574 575 576 577 578 579 580 581 582 583 584 585 586 587
#-----------------------------------------------------------
# lbu_diff - run a diff against last commit
usage_diff() {
	echo "$PROGRAM $VERSION
Run a diff against last commit

usage: $PROGRAM diff [<media>]
"
	exit 1
}

cmd_diff() {
	LBU_MEDIA=${1:-"$LBU_MEDIA"}
	[ -z "$LBU_MEDIA" ] && usage_diff
	local tmp
	init_tmpdir tmp
	mkdir -p "$tmpdir/a" "$tmp/b"
	unpack_apkovl "$tmp/a"
	cmd_package - | tar -C "$tmp/b" -zx
	cd "$tmp" && diff -ruN a b 
}
	

Natanael Copa's avatar
Natanael Copa committed
588 589 590 591 592 593 594 595 596 597 598 599 600 601 602 603 604

#-----------------------------------------------------------
# Main

cmd=`echo "$PROGRAM" | cut -s -d_ -f2`
PROGRAM=`echo "$PROGRAM" | cut -d_ -f1`
if [ -z "$cmd" ] ; then
	cmd="$1"
	[ -z "$cmd" ] && usage
	shift
fi

# check for valid sub command
case "$cmd" in
	include|inc|add)	SUBCMD="include";;
	commit|ci)		SUBCMD="commit";;
	exclude|ex|delete)	SUBCMD="exclude";;
605 606
	list|ls)		SUBCMD="list";;
	package|pkg)		SUBCMD="package";;
Natanael Copa's avatar
Natanael Copa committed
607
	status|stat|st)		SUBCMD="status";;
608
	list-backup|lb)		SUBCMD="listbackup";;
Natanael Copa's avatar
Natanael Copa committed
609
	revert)			SUBCMD="revert";;
610
	diff)			SUBCMD="diff";;
Natanael Copa's avatar
Natanael Copa committed
611 612 613 614
	*)			usage;;
esac

# parse common args
615
while getopts "adehlM:np:qrv" opt ; do
Natanael Copa's avatar
Natanael Copa committed
616 617 618 619
	case "$opt" in
		a) 	[ $SUBCMD = status ] || usage_$SUBCMD
			USE_DEFAULT="-a"
			;;
620 621
		d)	DELETEOLDCONFIGS="yes"
			;;
622
		e)	[ -z "$ENCRYPTION" ] && ENCRYPTION="$DEFAULT_CIPHER"
623
			;;
Natanael Copa's avatar
Natanael Copa committed
624 625 626 627 628 629 630
		h) 	usage_$SUBCMD
			;;
		l)	LIST="-l"
			;;
		n) 	[ $SUBCMD = commit ] || usage_$SUBCMD
			DRYRUN="-n"
			;;
631 632
		p)	PASSWORD="$OPTARG"
			;;
Natanael Copa's avatar
Natanael Copa committed
633 634 635 636 637 638 639 640 641
		q)	QUIET="$QUIET -q"
			;;
		r)	REMOVE="-r"
			;;
		v) 	VERBOSE="$VERBOSE -v"
			;;
	esac
done
shift `expr $OPTIND - 1`
642

Natanael Copa's avatar
Natanael Copa committed
643
trap exit_clean SIGINT SIGTERM
644
cmd_$SUBCMD "$@"
Natanael Copa's avatar
Natanael Copa committed
645 646 647
retcode=$?

cleanup
Natanael Copa's avatar
Natanael Copa committed
648
exit $retcode